local Zifnabs_RP = {}
_G.Zifnabs_RP = Zifnabs_RP

local default_settings={
	["rp_say"]={
		[1]={["caption"]=Zifnabs.LANG.RP_HI,["notarget"]={Zifnabs.LANG.RP_HI_NOTARGET1,Zifnabs.LANG.RP_HI_NOTARGET2},["any"]={Zifnabs.LANG.RP_HI_ANY1,Zifnabs.LANG.RP_HI_ANY2},["female"]={},["male"]={}},
		[2]={["caption"]=Zifnabs.LANG.RP_BYE,["notarget"]={Zifnabs.LANG.RP_BYE_NOTARGET1,Zifnabs.LANG.RP_BYE_NOTARGET2},["any"]={Zifnabs.LANG.RP_BYE_ANY1,Zifnabs.LANG.RP_BYE_ANY2},["female"]={},["male"]={}},
		[3]={["caption"]=Zifnabs.LANG.RP_THANKS,["notarget"]={Zifnabs.LANG.RP_THANKS_NOTARGET1,Zifnabs.LANG.RP_THANKS_NOTARGET2},["any"]={Zifnabs.LANG.RP_THANKS_ANY1,Zifnabs.LANG.RP_THANKS_ANY2},["female"]={},["male"]={}},
	},
}
for b=1,12,1 do
	if default_settings.rp_say[b]==nil then default_settings.rp_say[b]={["caption"]="",["any"]={}} end
end
local settings={}

local my_name="Zifnabs_RolePlay"
local control=getglobal("Zifnabs_RP_Control")

Zifnabs:plugin("Zifnabs_RP",Zifnabs_RP,false)

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_RP:OnEvent(event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)
	if event=="VARIABLES_LOADED" then
		Zifnabs_RP:reload_settings()
		Zifnabs:dofile("Zifnabs_Config_RP")	
--		control:RegisterEvent("CASTING_START")
--		control:RegisterEvent("CASTING_STOP")
--		control:RegisterEvent("CASTING_FAILED")
--		control:RegisterEvent("CASTING_DELAYED")
--		control:RegisterEvent("CHAT_MSG_CHANNEL")
--		control:RegisterEvent("CHAT_MSG_COMBAT")
--		control:RegisterEvent("CHAT_MSG_GUILD")
--		control:RegisterEvent("CHAT_MSG_PARTY")
--		control:RegisterEvent("CHAT_MSG_SAY")
--		control:RegisterEvent("CHAT_MSG_SYSTEM")
--		control:RegisterEvent("CHAT_MSG_WHISPER")
--		control:RegisterEvent("CHAT_MSG_YELL")
--		control:RegisterEvent("CHAT_MSG_ZONE")
--		control:RegisterEvent("COMBATMETER_DAMAGE")
--		control:RegisterEvent("COMBATMETER_HEAL")
--		control:RegisterEvent("COUNTDOWN_END")
--		control:RegisterEvent("EXCHANGECLASS_SUCCESS")
--		control:RegisterEvent("FOCUS_CHANGED")
--		control:RegisterEvent("LOADING_END")		-- Loading of Zone ended
--		control:RegisterEvent("PARTY_INVITE_REQUEST")
--		control:RegisterEvent("PARTY_MEMBER_CHANGED")
--		control:RegisterEvent("PLAYER_ENTER_COMBAT")
--		control:RegisterEvent("PLAYER_LEAVE_COMBAT")
--		control:RegisterEvent("PLAYER_DEAD")
--		control:RegisterEvent("PLAYER_ALIVE")
--		control:RegisterEvent("TARGET_HATE_LIST_UPDATED")
--		control:RegisterEvent("UNIT_BUFF_CHANGED")
--		control:RegisterEvent("UNIT_HEALTH")
--		control:RegisterEvent("UNIT_MANA")
--		control:RegisterEvent("UNIT_TARGET_CHANGED")
--		control:RegisterEvent("WARNING_START")
--		control:RegisterEvent("WARNING_STOP")	
--		control:RegisterEvent("ZONE_CHANGED")		
	elseif event=="SAVE_VARIABLES" then
		Zifnabs:save_settings(default_settings,settings)
	else Zifnabs:echo("RP: "..event.." "..type(arg1).." "..type(arg2))		
	end
end

function Zifnabs_RP:reload_settings()
	settings=Zifnabs:init_settings(default_settings)
	local highest=0
	for b=1,12,1 do
		local button=getglobal(my_name.."_"..b)
		if settings.rp_say[b]["caption"]=="" then button:Hide()
		else
			button:Show()
			highest=math.ceil(b/3)
			button:SetText(settings.rp_say[b]["caption"])
		end
	end
	getglobal("Zifnabs_RolePlay"):SetHeight(20*highest)
end

function Zifnabs_RP:button(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	local bnumber=1*part[#part]

	local table1={}
	local table2={}
	local message=""
	if (UnitExists("target")) then
		table1=settings.rp_say[bnumber]["any"]
		if UnitIsUnit("player","target") then table1=settings.rp_say[bnumber]["notarget"]
		elseif UnitIsPlayer("target") and UnitSex("target")==0 then table2=settings.rp_say[bnumber]["male"]
		elseif UnitIsPlayer("target") and UnitSex("target")==1 then table2=settings.rp_say[bnumber]["female"]
		end
	else
		table1=settings.rp_say[bnumber]["notarget"]
	end
	if table1==nil then table1=settings.rp_say[bnumber]["any"] end
	if table2==nil then table2={} end
	local select=math.random(#table1+#table2)
	if select<=#table1 then	message=table1[select] else message=table2[select-#table1] end
	if message then
		local channel="SAY"
		local choice=string.lower(string.sub(message,1,2))
		local valid={["/s"]="SAY",["/g"]="GUILD",["/p"]="PARTY",["/z"]="ZONE",["/w"]="WORLD"}
		if valid[choice] then
			channel=valid[choice]
			message=string.sub(message,3)
		end
		SendChatMessage(message, channel, 0);
	else
		Zifnabs:error(Zifnabs.LANG.RP_NO_MESSAGE)
	end
end
